package applicatif;

import java.awt.*;
import java.awt.event.*;
import java.util.Hashtable;
import java.beans.*;

import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.undo.*;
import javax.swing.border.*;
import java.net.*;

/**
 * Classe implmentant l'action de rtablir
 */
public class RedoAction extends AbstractAction {

  private static final String ICONE_GENERAL_PATH = "toolbarButtonGraphics/general/";

    protected UndoManager gestionnaireUndo;
    protected UndoAction undoAction;

    public RedoAction(UndoManager m) {
      super("Redo");
      gestionnaireUndo = m;
      setEnabled(false);
      putValue(Action.NAME, "Rtablir");
      putValue(Action.SMALL_ICON, 
               ihm.GestionnaireIcone.getIcone(ICONE_GENERAL_PATH,
                                               "Redo16.gif"));
    }
    
    public void actionPerformed(ActionEvent e) {
      //rtablir la dernire action
      try {
        gestionnaireUndo.redo();
      } catch (CannotRedoException ex) {
        System.out.println("Impossible de rtablir: " + ex);
        ex.printStackTrace();
      }
      // mise  jour de l'tat des menus (actifs ou non)
      majEtat();
      undoAction.majEtat();
    }
    
    public void majEtat() {
      setEnabled(gestionnaireUndo.canRedo());
    }

    public void setUndoAction(UndoAction act) {
      undoAction = act;
    }
  }    