package applicatif;         

import java.awt.event.ActionEvent;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.undo.*;
import java.net.URL;

/**
 * Classe implmentant l'action d'annulation
 */
public class UndoAction extends AbstractAction {

  private static final String ICONE_GENERAL_PATH = "toolbarButtonGraphics/general/"; 
  protected UndoManager gestionnaireUndo;
  protected RedoAction redoAction;

  /**
   * Construction de UndoAction, avec un nom et une icne
   */
  public UndoAction(UndoManager m) {
    super("Undo");
    gestionnaireUndo = m;
    setEnabled(false);
    putValue(Action.NAME, "Annuler");
    putValue(Action.SMALL_ICON, 
             ihm.GestionnaireIcone.getIcone(ICONE_GENERAL_PATH,
                                             "Undo16.gif"));
  }

  public void actionPerformed(ActionEvent e) {
    //annuler la dernire action
    try {
      gestionnaireUndo.undo();
    } catch (CannotUndoException ex) {
      System.out.println("Impossible d'annuler: " + ex);
      ex.printStackTrace();
    }
    //mise  jour de l'tat des boutons (dispo ou non)
    majEtat();
    redoAction.majEtat();
  }

  /**
   * Met  jour l'tat (disponible ou non) de l'action
   * et par extension de tous les composants graphiques
   * reprsentant cette action.
   */
  public void majEtat() {
    setEnabled(gestionnaireUndo.canUndo());
    //putValue(Action.NAME, "Annuler "+gestionnaireUndo.getPresentationName());
  }

  /**
   * Accesseur pour l'action Rtablir
   */
  public void setRedoAction(RedoAction act) {
    redoAction = act;
  }
}
