package ihm;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import metier.*;

/**
 * Ce listener a pour rle de mettre  jour la panneau de
 * droite dans la fentre principale avec les informations du
 * noeud qui vient d'tre slectionn. 
 * Par ailleurs, les modifications sur l'objet mtier qui vient 
 * d'tre dslectionn sont enregistres. 
 */
public class ArbreSelectListener implements TreeSelectionListener {

  PanneauDetail panneauCible;
  
  public ArbreSelectListener(PanneauDetail pan) {
    panneauCible = pan;
  }
    
  /**
   * Cette mthode est appele lorsqu'un changement de slection a lieu. 
   */
  public void valueChanged(TreeSelectionEvent e) {
    // Enregistrement du noeud qui vient d'tre dslectionn
    TreePath chemin = e.getOldLeadSelectionPath();
    if (chemin != null) {
      DefaultMutableTreeNode noeudDeselect = (DefaultMutableTreeNode)chemin.getLastPathComponent();
      Noeud omDeselect = (Noeud) noeudDeselect.getUserObject();
      Noeud omModifie = panneauCible.enregistrerNoeud(omDeselect);
      // Dans la cas ou omDeselect a chang de nature 
      // (catgorie -> signet par exemple), il faut affecter ce nouveau
      // noeud  l'objet graphique TreeNode
      noeudDeselect.setUserObject(omModifie);      
    }
  
    // Affichage du dtail du nouveau noeud slectionn
    TreePath cheminNouveau = e.getNewLeadSelectionPath();
    if (cheminNouveau != null) {
      DefaultMutableTreeNode noeudSelect = (DefaultMutableTreeNode)cheminNouveau.getLastPathComponent();
      if (noeudSelect != null) {
        Noeud omSelect = (Noeud) noeudSelect.getUserObject();
        if (omSelect != null) {
          panneauCible.afficherNoeud(omSelect);
        }
      }
    }
    
 
  }  
}