package ihm;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import javax.swing.*;
import javax.swing.tree.*;
import java.io.*;

import metier.*;

public class ArbreSignet extends JTree {
	
	protected class SrcDragGestureListener 
				implements DragGestureListener {
		public void dragGestureRecognized(DragGestureEvent event) {
			TreePath tp = ArbreSignet.this.getSelectionPath();
		    DefaultMutableTreeNode noeud_a_deplacer = 
						(DefaultMutableTreeNode)tp.getLastPathComponent();
		    if ( noeud_a_deplacer != null ){
		        NoeudTransferable transferable = 
									new NoeudTransferable(noeud_a_deplacer);
		        event.startDrag(DragSource.DefaultMoveDrop,
								transferable,
								srcDragSourceListener);
		    } else {
		        System.out.println("Selectionnez un noaud !");
		    }		
		}
	}
	
	protected class DragGestureManager implements DragGestureListener {
		public void dragGestureRecognized(DragGestureEvent event) {

		}
	}
	
	protected class SrcDragSourceListener 
				implements DragSourceListener {
		public void dragDropEnd(DragSourceDropEvent event) {
			if ( event.getDropSuccess()){
		    }
		}
		public void dragEnter(DragSourceDragEvent dsde) {
		}
		public void dragExit(DragSourceEvent dse) {
		}
		public void dragOver(DragSourceDragEvent dsde) {
		}
		public void dropActionChanged(DragSourceDragEvent dsde) {
		}
	}

	protected class DestDropTargetListener 
				implements DropTargetListener {
		public void dragEnter(DropTargetDragEvent event) {
		    //event.acceptDrag(DnDConstants.ACTION_MOVE);
			//event.rejectDrag();
		}
		public void dragExit(DropTargetEvent dte) {
		}
		public void dragOver(DropTargetDragEvent dtde) {
		}
		public void drop(DropTargetDropEvent event) {
		    try {
        		Transferable transferable = event.getTransferable();
	   			 // Nous n'acceptons que les DefaultMutableTreeNode
		        if (transferable.isDataFlavorSupported(
							NoeudTransferable.getNoeudFlavor())) {
        	        //
	    	        DefaultMutableTreeNode s = (DefaultMutableTreeNode)
								transferable.getTransferData(
										NoeudTransferable.getNoeudFlavor());
	        	    Point p = event.getLocation();
					TreePath tp = ArbreSignet.this.getPathForLocation(p.x, p.y);
				    DefaultMutableTreeNode parent = 
								(DefaultMutableTreeNode)tp.getLastPathComponent();
					// Verification que le noeud , furut parent
					// est bien une catgorie.
					if (!verifierCategorie(parent))  {
						System.out.println("Vous ne pouvez pas dposer ce noeud ici !");
						event.rejectDrop();
					} else {
						event.acceptDrop(DnDConstants.ACTION_MOVE);
						DefaultTreeModel model = 
									(DefaultTreeModel)ArbreSignet.this.getModel();
						parent.add(s);
						model.reload();
		            	event.getDropTargetContext().dropComplete(true);
					}
		        }  else {
					System.out.println("Drop refus !!!!!");
			        event.rejectDrop();
		        }
		    } catch (IOException exception) {
		        exception.printStackTrace();
		        System.err.println( "Exception" + exception.getMessage());
		        event.rejectDrop();
		    } catch (UnsupportedFlavorException ufException ) {
				ufException.printStackTrace();
				System.err.println( "Exception" + ufException.getMessage());
				event.rejectDrop();
		    }				
		}
		public void dropActionChanged(DropTargetDragEvent dtde) {
		}
	}
	
	protected class DropTargetManager implements DropTargetListener {
		public void dragEnter(DropTargetDragEvent event) {
		}
		public void dragExit(DropTargetEvent dte) {
		}
		public void dragOver(DropTargetDragEvent dtde) {
		}
		public void drop(DropTargetDropEvent event) {

		}
		public void dropActionChanged(DropTargetDragEvent dtde) {
			System.out.println( "dropActionChanged");
		}
	}
	
	protected DragSource dragSource = null;
	protected DropTarget dropTarget = null;
	
	protected SrcDragGestureListener srcDragGestureListener = 
				new SrcDragGestureListener();
	protected SrcDragSourceListener srcDragSourceListener = 
				new SrcDragSourceListener();
	protected DestDropTargetListener destDropTargetListener = 
				new DestDropTargetListener();


	protected void initDnD() {
		dragSource = DragSource.getDefaultDragSource();
		dragSource.createDefaultDragGestureRecognizer(this,
										DnDConstants.ACTION_MOVE,
										srcDragGestureListener);
		dropTarget = new DropTarget(this, destDropTargetListener);		
	}

	public ArbreSignet(DefaultMutableTreeNode racine) {
		super(racine);
		initDnD();
	}
	
	protected boolean verifierCategorie(DefaultMutableTreeNode n) {
		boolean result = false;
		Object o = n.getUserObject();
		if (o instanceof Categorie)  {
			result = true;
		}
		return result;
	}	
}