package ihm;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.undo.*;
import javax.swing.text.*;
import applicatif.*;
import java.net.*;
import java.io.*;

/**
 * Cette classe reprsente une fentre qui permet de
 * visualiser une page HTML.
 */
public class FenetreHtml extends JDialog {

  // Variables lies a l'IHM
  protected JFrame fenetrePpale;
  protected JScrollPane jspHtml;
  protected JPanel panBoutons;
  protected JButton btFermer;
  protected JEditorPane editPaneHtml;

  protected URL url;

  /**
   * Constructeur de la fentre de visualisation d'une page HTML
   * @param fen la fentre principale  partir de laquelle une
   * instance de FenetreHtml se lance
   * @param url l'URL  afficher dans l'EditorPane
   */
  public FenetreHtml(JFrame fen, URL url) {
    super(fen, "Visualisation page HTML", true);
    fenetrePpale = fen;
    this.url = url;
    initialiserIHM(url);
    afficherURL();
    gererEvenements();
  }

  /**
   * Initialisation de l'IHM
   */
  public void initialiserIHM(URL url) {
    setSize(new Dimension(500, 300));
    panBoutons = new JPanel();
    btFermer = new JButton();
    btFermer.setText("Fermer");
    editPaneHtml = new JEditorPane();
    jspHtml = new JScrollPane(editPaneHtml);
    panBoutons.add(btFermer, null);
    getContentPane().add(jspHtml, BorderLayout.CENTER);
    getContentPane().add(panBoutons, BorderLayout.SOUTH);
  }

  /**
   * Affichage de l'URL dans l'EditorPane
   */
  public void afficherURL() {
    editPaneHtml.setEditable(false);
    try {
      editPaneHtml.setPage(url);
    } catch(IOException e) {
      e.printStackTrace();
    }
  }

  /**
   * Gestion des evenements : fermeture de la fentre et
   * clics sur liens hypertexte
   */
  public void gererEvenements() {
    // gestion de la fermeture de cette fentre
    this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
    btFermer.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        dispose();
      }
    });
    // gestion des liens hypertexte
    editPaneHtml.addHyperlinkListener( new HyperlinkListener() {
      public void hyperlinkUpdate(HyperlinkEvent e) {
        if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
          try {
            editPaneHtml.setPage(e.getURL());
          } catch(IOException ex) {
            ex.printStackTrace();
          }
        }
      }
    });
  }

}
