package ihm;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import applicatif.*;
import metier.*;

/**
 * Ce panneau permet d'afficher l'arbre des signets
 */
public class PanneauArbre extends JPanel {

  // Constantes
  private static final String CREER_TEXT = "Crer";
  private static final String SUPPR_TEXT = "Supprimer";

  // Variables d'instance lies  l'IHM
  protected FenetrePrincipale fenetrePpale;
  protected BorderLayout layout = new BorderLayout();
  protected JToolBar arbreBarreOutils;
  protected JScrollPane arbreScrollPane;
  protected JButton btCreer;
  protected JButton btSuppr;
  protected JTree arbre;
  
  // Les actions
  protected CreerNoeudAction creer;
  protected SupprNoeudAction suppr;
  
  /**
   * Constructeur. Ce constructeur cre un panneau. 
   */
  public PanneauArbre(FenetrePrincipale fen) {
    fenetrePpale = fen;
    setLayout(layout);
    initialiserArbre();
    initialiserActions();
    creerBarreOutils();
    add(arbreBarreOutils, BorderLayout.NORTH);
    add(arbreScrollPane, BorderLayout.CENTER);
  }

  /**
   * Cration de la barre d'outils
   */
  public void creerBarreOutils() {
    arbreBarreOutils = new JToolBar();
    btCreer = new JButton(creer);
    btSuppr = new JButton(suppr);
    arbreBarreOutils.add(btCreer);
    arbreBarreOutils.add(btSuppr);
  }

  /** 
   * Renvoie le composant JTree de ce panneau. 
   */
  public JTree getArbre() {
    return arbre;
  }
  
  /**
   * Initialisation des actions
   */
  public void initialiserActions() {
    creer = new CreerNoeudAction(arbre);
    creer.putValue(Action.NAME, CREER_TEXT);
    suppr = new SupprNoeudAction(arbre);
    suppr.putValue(Action.NAME, SUPPR_TEXT);
  }
  
  /**
   * Initialisation de l'arbre  l'ouverture
   */
  public void initialiserArbre() {
    CategoriePersistante racine = new CategoriePersistante("Racine");
    DefaultMutableTreeNode nRacine = new DefaultMutableTreeNode(racine);
    arbre = new ArbreSignet(nRacine);
    arbre.setCellRenderer(new ArbreRenderer());
    arbre.setRootVisible(true);
    arbreScrollPane = new JScrollPane(arbre);
    arbreScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    arbreScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    arbre.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    arbre.addTreeSelectionListener(new ArbreSelectListener(fenetrePpale.getPanneauDetail()));
  }
  
}

