
package metier;

import java.util.ArrayList;
import java.io.Serializable;

/**
 * Cette classe reprsente une catgorie dans laquelle on peut classer des signets
 * ou bien d'autres catgories. 
 */
public class Categorie extends Noeud implements Serializable {

  /**
   * Construit une catgorie
   *
   * @param nom nom de la catgorie
   */
  public Categorie (String nom) {
    this(nom, null);
  }

  /**
   * Construit une catgorie
   *
   * @param nom nom de la catgorie
   * @param desc description de la catgorie
   */
  public Categorie (String nom, String desc) {
    setNom(nom);
    setDescription(desc);
  }
}
