
package metier;

import java.net.URL;
import java.io.Serializable;

/**
 * Un signet est un objet contenant l'adresse d'un site Web favori.
 * Un signet appartient  une catgorie. 
 */
public class Signet extends Noeud implements Serializable {

  protected URL url;

  /**
   * Construit un signet
   *
   * @param nom nom du signet
   */
  public Signet (String nom) {
    this(nom, null, null);
  }
  /**
   * Construit un signet
   *
   * @param nom nom du signet
   * @param url l'url du signet
   */
  public Signet (String nom, URL url) {
    this(nom, url, null);
  }

  /**
   * Construit un signet
   *
   * @param nom nom du signet
   * @param url l'url du signet
   * @param desc description du signet
   */
  public Signet (String nom, URL url, String desc) {
    setNom(nom);
    setUrl(url);
    setDescription(desc);
  }
    
  public URL getUrl(){ 
    return url; 
  }

  public void setUrl(URL url){ 
    this.url = url; 
  }
}
